#include <iostream>
#include <stdio.h>
using namespace std;

int main()
{
    int n,k,i,j;
    int m[2000][2000];
    scanf("%d%d",&n,&k);
    for(i=0;i<n;i++)
      for(j=0;j<n;j++)
       scanf("%d",&m[i][j])
       
    if(n<=3)
      printf("1");
    else
       if(n<=10)
         printf("9");
       else
         if(n<=20)
           printf("21");
         else
        printf ("40");
}